# -------------------------------------------------------------------------------- NOTEBOOK-CELL: CODE
# -*- coding: utf-8 -*-
import dataiku
import pandas as pd, numpy as np
from dataiku import pandasutils as pdu
from pm4py.statistics.traces.generic.pandas import case_statistics

# Read recipe inputs
workflow_clean = dataiku.Dataset("workflow_clean")
workflow_clean_df = workflow_clean.get_dataframe()

# -------------------------------------------------------------------------------- NOTEBOOK-CELL: CODE
workflow_clean_df = workflow_clean_df.sort_values(by=['timestamp'])
variants_count = case_statistics.get_variant_statistics(workflow_clean_df,
                                      parameters={case_statistics.Parameters.CASE_ID_KEY: "case",
                                                  case_statistics.Parameters.ACTIVITY_KEY: "activity",
                                                  case_statistics.Parameters.TIMESTAMP_KEY: "timestamp"})

# -------------------------------------------------------------------------------- NOTEBOOK-CELL: CODE
variants_df = pd.DataFrame.from_dict(variants_count)

# -------------------------------------------------------------------------------- NOTEBOOK-CELL: CODE
# Write recipe outputs
variants = dataiku.Dataset("variants")
variants.write_with_schema(variants_df)